package magellan;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import java.util.*;
import java.beans.*;
import java.net.*;
import java.io.*;

public class Surveyor extends Applet {

  static int NUMBER_OF_SCALES = 3; // Default.
  static final int MAX_SCALES = 25;
  static final int NUMBER_OF_ADJECTIVES = 5;
  static final String NO_DATA = "99";
  static final String INITIAL_RATINGS[] = new String[MAX_SCALES];
  static final double MISSING_DATA = -99.0;
  static final String TEXT_DELIMITER = "|";
  static final int NUMBER_OF_TUTORIAL_LINES = 3;
  static final String COMMA_SPACE = ", ";
  static final String NEW_LINE = "\n";
  static final String QUOTE = "\"";
  static final String successHTM = "success.htm";

  static public Component appletFrame;
  static public Frame FRAME;
  static public AppletContext context;
  static public URL documentBase, successURL;
  static public String baseDirectory, codeBase;
  static public Locale currentLocale;
  static ResourceBundle InterfaceTexts; // = ResourceBundle.getBundle("magellan.Messages");
  static ResourceBundle StimuliSet; // = ResourceBundle.getBundle("magellan.Stimuli");
  private static final String MADE_BY_HEISE = " D. Heise, 2001.";

  Panel stopCard = new Panel();
  Panel ratingCard = new Panel();
  Panel questionnaireCard = new Panel();
  Panel paymentCard = new Panel();
  Panel optionCenteringPanel = new Panel();
  Panel questionOptionPanel = new Panel();
  Panel tutorialPanel = new Panel();
  Panel tutorialTextPanel = new Panel();
  Panel stimulusPanel = new Panel();
  Panel leftAdjectivePanel = new Panel();
  Panel rightAdjectivePanel = new Panel();
  Panel adverbPanel = new Panel();
  Panel saveButtonPanel = new Panel();
  Panel progressPanel = new Panel();
  Panel editPanel = new Panel();
  Panel messagePanel = new Panel();
  Panel formPanel = new Panel();
  Panel namePanel = new Panel();
  Panel address1Panel = new Panel();
  Panel address2Panel = new Panel();
  Panel cityPanel = new Panel();
  Panel submitButtonPanel = new Panel();

  Label stopTheSessionLabel = new Label();
  Label pinTextLabel = new Label();
  Label pinLabel = new Label();
  Label questionnaireInstruction = new Label();
  Label questionStub = new Label();
  Label[] tutorialLine = new Label[NUMBER_OF_TUTORIAL_LINES];
  Label Stimulus1 = new Label();
  Label Stimulus2 = new Label();
  Label leftAdjective0 = new Label();
  Label leftAdjective1 = new Label();
  Label leftAdjective2 = new Label();
  Label leftAdjective3 = new Label();
  Label leftAdjective4 = new Label();
  Label rightAdjective0 = new Label();
  Label rightAdjective1 = new Label();
  Label rightAdjective2 = new Label();
  Label rightAdjective3 = new Label();
  Label rightAdjective4 = new Label();
  Label infiniteL = new Label();
  Label extremeL = new Label();
  Label quiteL = new Label();
  Label slightL = new Label();
  Label neutral = new Label();
  Label slightR = new Label();
  Label quiteR = new Label();
  Label extremeR = new Label();
  Label infiniteR = new Label();
  Label progressLabel = new Label();
  Label editingInstruction = new Label();
  Label formInstruction1 = new Label();
  Label formInstruction2 = new Label();
  Label formInstruction3 = new Label();
  Label yourNameLabel = new Label();
  Label address1Label = new Label();
  Label address2Label = new Label();
  Label cityLabel = new Label();

  Checkbox[] option = new Checkbox[BackgroundQuestion.MAX_OPTIONS];
  CheckboxGroup optionsGroup = new CheckboxGroup();

  TextField yourNameField = new TextField();
  TextField address1Field = new TextField();
  TextField address2Field = new TextField();
  TextField cityField = new TextField();

  Button questionnaireContinueButton = new Button();
  Button tutorialButton = new Button();
  Button skipButton = new Button();
  Button saveButton = new Button();
  Button editButton = new Button();
  Button submitButton = new Button();

  java.awt.List listOfCompletedStimuli = new java.awt.List();

  Font cyberbitFont;

  Slider slider1 = new Slider();

  CardLayout appletCardLayout = new CardLayout();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  GridBagLayout gridBagLayoutQ = new GridBagLayout();
  GridLayout gridLayoutO = new GridLayout(BackgroundQuestion.MAX_OPTIONS,1);
  GridLayout gridLayout1 = new GridLayout();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayoutS = new GridLayout(2,1);
  GridLayout gridLayoutT = new GridLayout(3,1);
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout paymentLayout = new BorderLayout();
  BorderLayout paymentMessagesLayout = new BorderLayout();
  GridLayout paymentGridLayout = new GridLayout();

  String projectIdentification, stimuliSetIdentification, nameOfArchive;
  String positiveModifiers[][] = new String[MAX_SCALES][NUMBER_OF_ADJECTIVES];
  String negativeModifiers[][] = new String[MAX_SCALES][NUMBER_OF_ADJECTIVES];
  String language, country;
  int typesize = 10;
  int numberOfStimuliSets, forceStimulusSet, numberOfQuestions, questionIndex;
  Vector querySet;
  BackgroundQuestion currentQuestion;
  int currentTutorialPage;
  DataLine[] dataSet;
  int numberOfStimuli, currentStimulus, currentDimension, stimuliDone, startCountdownAt, ratingsDone;
  double sumSquaredRatings;
  boolean usingSaveButton, tutorialIncluded, presentingTutorial, adverbsOnOneLine, reflectedScale;
  boolean randomStimuliOrder, debuggingSkip;
  boolean anonymous, acquiringPersonalData;
  static boolean skippedStimulus;
  static public int numberOfSkippedStimuli;
  boolean concludingRatings = false;
  ActionEvent dummyEvent = new ActionEvent(this,0,"");
  Random randomizer = new Random();
  long startTime, timeNow, timeIncrement, ratingTime;
  long baseTime = 996857593550L; // August 3, 2001
  String PINstring, respondentInfo, successURLstring, emailAddress;

  /**Construct the applet*/
  public Surveyor() {
  }
  /**Initialize the applet*/
  public void init() {

    // Read the applet parameters.
    String parameter = "";
    try {parameter = getParameter("BeginCountdownAt");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      startCountdownAt = 0;
    } else {
      startCountdownAt = Integer.parseInt(parameter);
    }
    try {parameter = getParameter("UseSaveButton");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      usingSaveButton  = false;
    } else {
      usingSaveButton = parameter.equalsIgnoreCase("true");
    }
    try {parameter = getParameter("GiveTutorial");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      tutorialIncluded = true;
    } else {
      tutorialIncluded = parameter.equalsIgnoreCase("true");
    }
    try {parameter = getParameter("NumberOfStimuliSets");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      numberOfStimuliSets = 1;
    } else {
      numberOfStimuliSets = Integer.parseInt(parameter);
    }
    try {parameter = getParameter("ForceStimuliSet");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      forceStimulusSet = 0;
      randomStimuliOrder = true;
    } else {
      forceStimulusSet = Integer.parseInt(parameter);
      if (forceStimulusSet < 0) { // Negative means fixed order for stimuli.
        forceStimulusSet = - forceStimulusSet;
        randomStimuliOrder = false;
      } else {
        // forceStimulusSet = parameter value
        randomStimuliOrder = true;
      }
    }
    try {parameter = getParameter("DebuggingSkip");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      debuggingSkip = false;
    } else {
      debuggingSkip = true;
    }
    try {parameter = getParameter("Language");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      language = "en";
    } else {
      language = parameter;
    }
    try {parameter = getParameter("Country");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      country = "US";
    } else {
      country = parameter;
    }
    try {parameter = getParameter("Typesize");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      typesize = 10;
    } else {
      typesize = Integer.parseInt(parameter);
    }
    try {parameter = getParameter("LineOfAdverbs");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      adverbsOnOneLine = true;
    } else {
      adverbsOnOneLine = parameter.equalsIgnoreCase("true");
    }
    try {parameter = getParameter("MeasuresPerStimulus");} catch(Exception e) {e.printStackTrace();}
    if (parameter!=null) {
      NUMBER_OF_SCALES = Integer.parseInt(parameter); // Else use static initial value.
    }
    try {parameter = getParameter("AcquirePersonalInfo");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      acquiringPersonalData = true;
    } else {
      acquiringPersonalData = parameter.equalsIgnoreCase("true");
    }
    try {parameter = getParameter("Anonymous");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      anonymous = true;
    } else {
      anonymous = parameter.equalsIgnoreCase("true");
    }
    if (!acquiringPersonalData) {
      anonymous = true;
      }
    try {parameter = getParameter("successURL");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      successURLstring = "";
    } else {
      successURLstring = parameter;
    }
    try {parameter = getParameter("emailAddress");} catch(Exception e) {e.printStackTrace();}
    if (parameter==null) {
      emailAddress = "socpsy@indiana.edu";
    } else {
      emailAddress = parameter;
      if (emailAddress.equalsIgnoreCase("")) {emailAddress = "socpsy@indiana.edu";}
    }
    try {
      jbInit();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
//    cyberbitFont = new Font ("Bitstream Cyberbit", Font.PLAIN, 12);
    currentLocale = new Locale(language,country);
    // We need the encompassing frame to define dialogs.
    appletFrame = getParent();
    while ((appletFrame != null) && !(appletFrame instanceof Frame)) {
      appletFrame = appletFrame.getParent();
    }
    FRAME = (Frame) appletFrame;
    // Get name of base directory for HTML calls.
    documentBase = getDocumentBase();
    codeBase = getCodeBase().toString();
    context = getAppletContext();

    this.setLayout(appletCardLayout);
    this.add("stopCard", stopCard);
    this.add("ratingCard", ratingCard);
    this.add("questionnaireCard", questionnaireCard);
    this.add("paymentCard", paymentCard);

    /**
     * Layout stopCard
     */
    stopCard.add(stopTheSessionLabel);
    stopCard.add(pinTextLabel);
    stopCard.add(pinLabel);

    /**
     * Layout questionnaireCard
     */
    questionnaireCard.setLayout(gridBagLayoutQ);
    questionnaireCard.setBackground(Color.white);

    questionnaireCard.add(questionnaireInstruction, new GridBagConstraints_(0, 0, 1, 1, 0.0, 2.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    questionnaireCard.add(questionStub, new GridBagConstraints_(0, 1, 1, 1, 0.0, 1.0
            ,GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    questionStub.setBackground(Color.white);
    questionStub.setText("");
    questionnaireCard.add(optionCenteringPanel, new GridBagConstraints_(0, 2, 1, 1, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    optionCenteringPanel.setBackground(Color.white);
    optionCenteringPanel.add(questionOptionPanel);
    questionOptionPanel.setBackground(Color.white);
    questionOptionPanel.setLayout(gridLayoutO);
    for (int i=0; i<BackgroundQuestion.MAX_OPTIONS; i++) {
      option[i] = new Checkbox();
      option[i].setBackground(Color.white);
      option[i].setCheckboxGroup(optionsGroup);
      option[i].setLabel("");
      option[i].setVisible(true);
      questionOptionPanel.add(option[i], null);
    }
    option[BackgroundQuestion.MAX_OPTIONS-1].setLabel(BackgroundQuestion.DUMMY_OPTION);
    option[BackgroundQuestion.MAX_OPTIONS-1].setVisible(false);
    option[BackgroundQuestion.MAX_OPTIONS-1].setState(true);
    questionnaireCard.add(questionnaireContinueButton, new GridBagConstraints_(0, 3, 1, 1, 0.0, 2.0
            ,GridBagConstraints.NORTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    questionnaireContinueButton.setLabel("");

    /**
     * Layout ratingCard
     */
    ratingCard.setLayout(gridBagLayout1);
    ratingCard.setBackground(Color.white);

    tutorialPanel.setBackground(Color.white);
    tutorialPanel.add(tutorialTextPanel);
    tutorialTextPanel.setLayout(gridLayoutT);
    for (int i=0; i<NUMBER_OF_TUTORIAL_LINES; i++) {
      tutorialLine[i] = new Label();
      tutorialLine[i].setBackground(Color.white);
      tutorialLine[i].setForeground(Color.blue);
      tutorialTextPanel.add(tutorialLine[i],null);
    }
    tutorialPanel.add(tutorialButton);
    tutorialButton.setVisible(false);

    stimulusPanel.setBackground(Color.white);
    Stimulus1.setBackground(Color.white);
    Stimulus2.setBackground(Color.white);
    stimulusPanel.setLayout(gridLayoutS);
    Stimulus1.setAlignment(1);
    Stimulus2.setAlignment(1);

//GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
    Stimulus1.setFont(new java.awt.Font("Dialog", 0, typesize+4));
    Stimulus2.setFont(new java.awt.Font("Dialog", 0, typesize+4));
    leftAdjective0.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    leftAdjective1.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    leftAdjective2.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    leftAdjective3.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    leftAdjective4.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    rightAdjective0.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    rightAdjective1.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    rightAdjective2.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    rightAdjective3.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    rightAdjective4.setFont(new java.awt.Font("Dialog", 0, typesize+2));
    infiniteL.setFont(new java.awt.Font("Dialog", 0, typesize));
    extremeL.setFont(new java.awt.Font("Dialog", 0, typesize));
    quiteL.setFont(new java.awt.Font("Dialog", 0, typesize));
    slightL.setFont(new java.awt.Font("Dialog", 0, typesize));
    neutral.setFont(new java.awt.Font("Dialog", 0, typesize));
    slightR.setFont(new java.awt.Font("Dialog", 0, typesize));
    quiteR.setFont(new java.awt.Font("Dialog", 0, typesize));
    extremeR.setFont(new java.awt.Font("Dialog", 0, typesize));
    infiniteR.setFont(new java.awt.Font("Dialog", 0, typesize));

    leftAdjectivePanel.setBackground(Color.white);
    leftAdjective0.setBackground(Color.white);
    leftAdjective1.setBackground(Color.white);
    leftAdjective2.setBackground(Color.white);
    leftAdjective3.setBackground(Color.white);
    leftAdjective4.setBackground(Color.white);
    leftAdjectivePanel.setLayout(gridLayout1);
    gridLayout1.setRows(5);
    gridLayout1.setColumns(1);
    leftAdjective0.setAlignment(2);
    leftAdjective1.setAlignment(2);
    leftAdjective2.setAlignment(2);
    leftAdjective3.setAlignment(2);
    leftAdjective4.setAlignment(2);

    rightAdjectivePanel.setBackground(Color.white);
    rightAdjective0.setBackground(Color.white);
    rightAdjective1.setBackground(Color.white);
    rightAdjective2.setBackground(Color.white);
    rightAdjective3.setBackground(Color.white);
    rightAdjective4.setBackground(Color.white);
    rightAdjectivePanel.setLayout(gridLayout2);
    gridLayout2.setRows(5);
    gridLayout2.setColumns(1);

    adverbPanel.setLayout(gridBagLayout2);
    adverbPanel.setBackground(Color.white);
    infiniteL.setBackground(Color.white);
    extremeL.setBackground(Color.white);
    quiteL.setBackground(Color.white);
    slightL.setBackground(Color.white);
    neutral.setBackground(Color.white);
    slightR.setBackground(Color.white);
    quiteR.setBackground(Color.white);
    extremeR.setBackground(Color.white);
    infiniteR.setBackground(Color.white);
    infiniteL.setAlignment(1);
    extremeL.setAlignment(1);
    quiteL.setAlignment(1);
    slightL.setAlignment(1);
    neutral.setAlignment(1);
    slightR.setAlignment(1);
    quiteR.setAlignment(1);
    extremeR.setAlignment(1);
    infiniteR.setAlignment(1);

    saveButtonPanel.setBackground(Color.white);

    progressPanel.setLayout(flowLayout1);
    flowLayout1.setHgap(30);
    progressPanel.setBackground(Color.white);
    progressLabel.setBackground(Color.white);
    progressLabel.setForeground(Color.green);
    progressLabel.setAlignment(1);

    editPanel.setLayout(borderLayout1);
    editPanel.setBackground(Color.white);
    editingInstruction.setBackground(Color.white);
    editingInstruction.setForeground(Color.blue);
    listOfCompletedStimuli.setBackground(Color.white);
    listOfCompletedStimuli.setFont(new java.awt.Font("Dialog", 0, 10));

    ratingCard.add(tutorialPanel, new GridBagConstraints_(0, 0, 3, 1, 4.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    ratingCard.add(stimulusPanel, new GridBagConstraints_(0, 1, 3, 1, 4.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    stimulusPanel.add(Stimulus1, null);
    stimulusPanel.add(Stimulus2, null);

    ratingCard.add(slider1, new GridBagConstraints_(1, 2, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    slider1.setBackground(Color.white);
    slider1.setShowingDigitLabels(false);
    if (usingSaveButton) {
      slider1.setSnappingToOrigin(false);
    } else {
      slider1.setSnappingToOrigin(true);
    }

    ratingCard.add(leftAdjectivePanel, new GridBagConstraints_(0, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    leftAdjectivePanel.add(leftAdjective0, null);
    leftAdjectivePanel.add(leftAdjective1, null);
    leftAdjectivePanel.add(leftAdjective2, null);
    leftAdjectivePanel.add(leftAdjective3, null);
    leftAdjectivePanel.add(leftAdjective4, null);
    ratingCard.add(rightAdjectivePanel, new GridBagConstraints_(2, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    rightAdjectivePanel.add(rightAdjective0, null);
    rightAdjectivePanel.add(rightAdjective1, null);
    rightAdjectivePanel.add(rightAdjective2, null);
    rightAdjectivePanel.add(rightAdjective3, null);
    rightAdjectivePanel.add(rightAdjective4, null);
    ratingCard.add(adverbPanel, new GridBagConstraints_(1, 3, 1, 1, 2.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));

    if (adverbsOnOneLine) {
      int adverbCols[] = {65, 50, 50, 50, 50, 50, 50, 50, 65};
      gridBagLayout2.columnWidths = adverbCols;
      adverbPanel.add(infiniteL, new GridBagConstraints_(0, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(extremeL, new GridBagConstraints_(1, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(quiteL, new GridBagConstraints_(2, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(slightL, new GridBagConstraints_(3, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(neutral, new GridBagConstraints_(4, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(slightR, new GridBagConstraints_(5, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(quiteR, new GridBagConstraints_(6, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(extremeR, new GridBagConstraints_(7, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(infiniteR, new GridBagConstraints_(8, 0, 1, 1, 0.0, 0.0
              ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 7), 0, 0));
    } else {
      int adverbCols[] = {22,25, 25,25, 25,25, 25,25, 25,25, 25,25, 25,25, 25,25, 25,22};
      gridBagLayout2.columnWidths = adverbCols;
      adverbPanel.add(infiniteL, new GridBagConstraints_(0, 0, 3, 1, 0.0, 0.0
              ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(extremeL, new GridBagConstraints_(2, 1, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(quiteL, new GridBagConstraints_(4, 0, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(slightL, new GridBagConstraints_(6, 1, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(neutral, new GridBagConstraints_(8, 0, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(slightR, new GridBagConstraints_(10, 1, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(quiteR, new GridBagConstraints_(12, 0, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(extremeR, new GridBagConstraints_(14, 1, 4, 1, 0.0, 0.0
              ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
      adverbPanel.add(infiniteR, new GridBagConstraints_(16, 0, 3, 1, 0.0, 0.0
              ,GridBagConstraints.EAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 7), 0, 0));
    }
    ratingCard.add(saveButtonPanel, new GridBagConstraints_(0, 4, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(40, 0, 0, 0), 0, 0));
    saveButtonPanel.add(saveButton, null);
    if (usingSaveButton) {
      saveButton.setVisible(true);
    } else {
      saveButton.setVisible(false);
    }
    ratingCard.add(progressPanel, new GridBagConstraints_(0, 5, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    progressPanel.add(editButton, null);
    progressPanel.add(progressLabel, null);
    progressPanel.add(skipButton, null);
    ratingCard.add(editPanel, new GridBagConstraints_(0, 6, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    editPanel.add(listOfCompletedStimuli, BorderLayout.CENTER);
    editPanel.add(editingInstruction, BorderLayout.NORTH);
    editPanel.setVisible(false);

    /**
     * Layout paymentCard
     */
    paymentCard.setLayout(paymentLayout);
    messagePanel.setLayout(paymentMessagesLayout);
    formPanel.setLayout(paymentGridLayout);
    paymentGridLayout.setRows(5);
    paymentGridLayout.setColumns(1);

    messagePanel.setBackground(Color.white);
    formInstruction1.setBackground(Color.white);
    formInstruction2.setBackground(Color.white);
    submitButtonPanel.setBackground(Color.white);
    formInstruction3.setBackground(Color.cyan);
    formPanel.setBackground(Color.cyan);
    namePanel.setBackground(Color.cyan);
    address1Panel.setBackground(Color.cyan);
    address2Panel.setBackground(Color.cyan);
    cityPanel.setBackground(Color.cyan);
    yourNameField.setBackground(Color.white);
    address1Field.setBackground(Color.white);
    address2Field.setBackground(Color.white);
    cityField.setBackground(Color.white);
    submitButton.setBackground(new Color(0, 204, 204)); // dark cyan.

    formInstruction1.setAlignment(1);
    formInstruction2.setAlignment(1);
    formInstruction3.setAlignment(1);

    yourNameField.setColumns(30);
    address1Field.setColumns(30);
    address2Field.setColumns(30);
    cityField.setColumns(30);

    paymentCard.add(messagePanel, BorderLayout.NORTH);
    paymentCard.add(formPanel, BorderLayout.CENTER);
    paymentCard.add(submitButtonPanel, BorderLayout.SOUTH);
    messagePanel.add(formInstruction1, BorderLayout.CENTER);
    messagePanel.add(formInstruction2, BorderLayout.SOUTH);
    formPanel.add(formInstruction3, null);
    formPanel.add(namePanel, null);
    namePanel.add(yourNameLabel, null);
    namePanel.add(yourNameField, null);
    formPanel.add(address1Panel, null);
    address1Panel.add(address1Label, null);
    address1Panel.add(address1Field, null);
    formPanel.add(address2Panel, null);
    address2Panel.add(address2Label, null);
    address2Panel.add(address2Field, null);
    formPanel.add(cityPanel, null);
    cityPanel.add(cityLabel, null);
    cityPanel.add(cityField, null);
    submitButtonPanel.add(submitButton, null);

    /**
     * Establish listeners
     */
    questionnaireContinueButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        questionnaireContinueButton_actionPerformed(e);
      }
    });
    tutorialButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        tutorialButton_actionPerformed(e);
      }
    });
   slider1.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(PropertyChangeEvent e) {
        slider1_propertyChange(e);
      }
    });
    saveButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    editButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        editButton_actionPerformed(e);
      }
    });
    skipButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        skipButton_actionPerformed(e);
      }
    });
    listOfCompletedStimuli.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        listOfCompletedStimuli_itemStateChanged(e);
      }
    });
    submitButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        submitButton_actionPerformed(e);
      }
    });

    /**
     * Start processes
     */
    translate(currentLocale);
    startTime = System.currentTimeMillis(); // Initialization.
    // Select desired start point.
    presentingTutorial = false;
    tutorialPanel.setVisible(false);
    numberOfSkippedStimuli = 0;
    if (numberOfQuestions>0) {
      appletCardLayout.show(this,"questionnaireCard");
      questionIndex = 0;
      presentQuestion();
    } else if (tutorialIncluded){
      giveTutorial();
    } else {
      beginRating();
    }
  } // End jbInit.

  void translate(Locale place) {
    InterfaceTexts = ResourceBundle.getBundle("magellan.Messages",place);
    String nameOfSet;
    if (forceStimulusSet > 0) {
      // Forcing a stimulus test for testing.
      nameOfSet = "magellan.Words_" + Integer.toString(forceStimulusSet);
    } else {
      // Input a stimuli set randomly.
      int stimuliSet = Math.abs(randomizer.nextInt() % numberOfStimuliSets) + 1;
      nameOfSet = "magellan.Words_" + Integer.toString(stimuliSet);
    }
    StimuliSet = ResourceBundle.getBundle(nameOfSet,place);
    readStimuli();
    // Set the buttons' texts and the label for stopping.
    questionnaireInstruction.setText(InterfaceTexts.getString("questionnaireInstruction"));
    questionnaireContinueButton.setLabel(InterfaceTexts.getString("questionnaireContinueButton"));
    tutorialButton.setLabel(InterfaceTexts.getString("tutorialButton"));
    saveButton.setLabel(InterfaceTexts.getString("saveButton"));
    skipButton.setLabel(InterfaceTexts.getString("skipButton"));
    editButton.setLabel(InterfaceTexts.getString("correctButton"));
    stopTheSessionLabel.setText(InterfaceTexts.getString("stopCardText"));
    // Get the adjective arrays.
    String dimNumeral, adjNumeral;
    String posName = "Pos_";
    String negName = "Neg_";
    for (int i=0; i<NUMBER_OF_SCALES; i++) {
      for (int j=0; j<NUMBER_OF_ADJECTIVES; j++) {
        dimNumeral = (new Integer(i+1)).toString();
        adjNumeral = (new Integer(j+1)).toString();
        positiveModifiers[i][j] = InterfaceTexts.getString(posName+dimNumeral+"_"+adjNumeral);
        negativeModifiers[i][j] = InterfaceTexts.getString(negName+dimNumeral+"_"+adjNumeral);
      }
    }
    // Set the adverbs.
    infiniteL.setText(InterfaceTexts.getString("infinitely"));
    extremeL.setText(InterfaceTexts.getString("extremely"));
    quiteL.setText(InterfaceTexts.getString("quite"));
    slightL.setText(InterfaceTexts.getString("slightly"));
    neutral.setText(InterfaceTexts.getString("neutral"));
    slightR.setText(InterfaceTexts.getString("slightly"));
    quiteR.setText(InterfaceTexts.getString("quite"));
    extremeR.setText(InterfaceTexts.getString("extremely"));
    infiniteR.setText(InterfaceTexts.getString("infinitely"));
    infiniteL.invalidate();
    extremeL.invalidate();
    quiteL.invalidate();
    slightL.invalidate();
    neutral.invalidate();
    slightR.invalidate();
    quiteR.invalidate();
    extremeR.invalidate();
    infiniteR.invalidate();
    tutorialPanel.invalidate();
    stimulusPanel.invalidate();
    leftAdjectivePanel.invalidate();
    rightAdjectivePanel.invalidate();
    adverbPanel.invalidate();
    saveButtonPanel.invalidate();
    editPanel.invalidate();
    // Incorporate editing instruction.
    editingInstruction.setText(InterfaceTexts.getString("EditingInstruction"));
    ratingCard.validate();
    // Set up personal information form.
    formInstruction1.setText(InterfaceTexts.getString("formInstruction1"));
    formInstruction2.setText(InterfaceTexts.getString("formInstruction2"));
    formInstruction3.setText(InterfaceTexts.getString("formInstruction3"));
    yourNameLabel.setText(InterfaceTexts.getString("yourName"));
    address1Label.setText(InterfaceTexts.getString("identification"));
    address2Label.setText(InterfaceTexts.getString("address"));
    cityLabel.setText(InterfaceTexts.getString("city"));
    submitButton.setLabel(InterfaceTexts.getString("submit"));
  } // End translate.

  void readStimuli () {
    // Read the project name and stimuli set.
    projectIdentification = StimuliSet.getString("projectIdentification");
    stimuliSetIdentification = StimuliSet.getString("stimuliSetIdentification");
    nameOfArchive = projectIdentification + stimuliSetIdentification;
    System.err.println(nameOfArchive); // Show info in Java Console.
    if (successURLstring.equalsIgnoreCase("")) {
      successURL = null;
    } else {
      try {successURL = new URL(successURLstring);}
      catch (MalformedURLException e) {System.out.println("Success URL is malformed.");}
    }
    // Get the questions and stimuli.
    String[] Stimulus = (String[]) StimuliSet.getStringArray("textArray");
    int numberOfInputLines = Stimulus.length;
    // Get background questions at front of stimuli list.
    querySet = new Vector();
    numberOfQuestions = 0;
    while (Stimulus[numberOfQuestions].startsWith(TEXT_DELIMITER)) {
      // First get the INDIGENOUS-LANGUAGE VERSION.
      String remainingText = Stimulus[numberOfQuestions];
      BackgroundQuestion question = new BackgroundQuestion();
      querySet.addElement(question);
      // Get rid of the first delimiter, and store text up to next delimiter.
      remainingText = remainingText.substring(remainingText.indexOf(TEXT_DELIMITER)+1);
      question.stub = remainingText.substring(0,remainingText.indexOf(TEXT_DELIMITER));
      // Parse the options.
      int choiceIndex = 0;
      do {
        // Get rid of the text at front, then store text up to next delimiter.
        remainingText = remainingText.substring(remainingText.indexOf(TEXT_DELIMITER)+1);
        question.option[choiceIndex++] = remainingText.substring(0,remainingText.indexOf(TEXT_DELIMITER));
      } while (remainingText.indexOf(TEXT_DELIMITER) != remainingText.lastIndexOf(TEXT_DELIMITER)); // Until only last delimiter remains.
      // Now get the ENGLISH-LANGUAGE VERSION.
      remainingText = Stimulus[numberOfQuestions+1];
      // Get rid of the first delimiter, and store text up to next delimiter.
      remainingText = remainingText.substring(remainingText.indexOf(TEXT_DELIMITER)+1);
      question.EnglishStub = remainingText.substring(0,remainingText.indexOf(TEXT_DELIMITER));
      // Parse the options.
      choiceIndex = 0;
      do {
        // Get rid of the text at front, then store text up to next delimiter.
        remainingText = remainingText.substring(remainingText.indexOf(TEXT_DELIMITER)+1);
        question.EnglishOption[choiceIndex++] = remainingText.substring(0,remainingText.indexOf(TEXT_DELIMITER));
      } while (remainingText.indexOf(TEXT_DELIMITER) != remainingText.lastIndexOf(TEXT_DELIMITER)); // Until only last delimiter remains.
      numberOfQuestions = numberOfQuestions + 2;
    }
    // Translate rating stimuli to dataSet, an array of DataLine.
    for (int i=0; i<MAX_SCALES; i=i+1) {
      INITIAL_RATINGS[i] = NO_DATA;
    }
    numberOfStimuli = (numberOfInputLines - numberOfQuestions) / 2;
    dataSet = new DataLine[numberOfStimuli];
    for (int i=0; i<2*numberOfStimuli; i=i+2) {
      // Read by pairs: indigenous stimulus, U.S.A. keyword.
      dataSet[i/2] = new DataLine(Stimulus[numberOfQuestions+i],Stimulus[numberOfQuestions+i+1],INITIAL_RATINGS);
    }
    stimuliDone = 0;
    ratingsDone = 0;
    sumSquaredRatings = 0.0;
    numberOfQuestions = numberOfQuestions / 2; // From here on we want number of indigenous-English pairs.
  } // End readStimuli.

  void presentQuestion() {
    currentQuestion = (BackgroundQuestion) querySet.elementAt(questionIndex);
    questionStub.invalidate();
    optionCenteringPanel.invalidate();
    questionOptionPanel.invalidate();
    questionStub.setText(currentQuestion.stub);
    for (int i=0; i<BackgroundQuestion.MAX_OPTIONS; i++) {
      option[i].setLabel("");
      option[i].setState(false);
      option[i].setVisible(false);
      option[i].invalidate();
    }
    option[BackgroundQuestion.MAX_OPTIONS-1].setLabel(BackgroundQuestion.DUMMY_OPTION);
    option[BackgroundQuestion.MAX_OPTIONS-1].setVisible(false);
    option[BackgroundQuestion.MAX_OPTIONS-1].setState(true);
    int optionIndex = -1;
    while (! currentQuestion.option[++optionIndex].equalsIgnoreCase("")) {
      option[optionIndex].setLabel(currentQuestion.option[optionIndex]);
      option[optionIndex].setVisible(true);
    }
    this.validate();
  } // End presentQuestion.

  void questionnaireContinueButton_actionPerformed(ActionEvent e) {
    // Get the answer.
    Checkbox selectedItem = optionsGroup.getSelectedCheckbox();
    if (selectedItem.getLabel()==BackgroundQuestion.DUMMY_OPTION) {
      return;
    }
    currentQuestion.storeAnswer(selectedItem);
System.err.print(selectedItem);
System.err.println(currentQuestion.answer);
    // Present next question, or go on to ratings.
    if (++questionIndex<numberOfQuestions){
      presentQuestion();
    } else if (tutorialIncluded){
      giveTutorial();
    } else {
      beginRating();
    }
  } // End questionnaireContinueButton_actionPerformed.

  void beginRating() {
    listOfCompletedStimuli.removeAll();
    currentStimulus = -1;
//    numberOfSkippedStimuli = 0;
    changeStimulus();
    changeDimension();
    appletCardLayout.show(this,"ratingCard");
    // Hocus pocus to make slider appear in Explorer.
    slider1.invalidate();
    leftAdjectivePanel.setVisible(false);
    rightAdjectivePanel.setVisible(false);
    slider1.setVisible(true);
    ratingCard.validate();
    ratingCard.invalidate();
    leftAdjectivePanel.setVisible(true);
    rightAdjectivePanel.setVisible(true);
    ratingCard.validate();
  } // End beginRating.

  void changeStimulus () {
    String testConcept;
    if (randomStimuliOrder & (stimuliDone+10<(numberOfStimuli))) {
      // Random draws for most stimuli.
      do { // Find an unrated stimulus.
        currentStimulus = Math.abs(randomizer.nextInt() % numberOfStimuli);
        testConcept = dataSet[currentStimulus].word;
      } while (dataSet[currentStimulus].itemDone);
    } else {
      // Systematic draws for last 10 stimuli; or if forceStimulusSet parameter is negative.
      currentStimulus = -1;
      while (dataSet[++currentStimulus].itemDone){};
      testConcept = dataSet[currentStimulus].word;
    }
    Stimulus1.invalidate();
    Stimulus2.invalidate();
    if (testConcept.indexOf(TEXT_DELIMITER)>0) {
      Stimulus1.setText(testConcept.substring(0,testConcept.indexOf(TEXT_DELIMITER)));
      Stimulus2.setText(testConcept.substring(testConcept.indexOf(TEXT_DELIMITER)+1));
    } else {
      Stimulus1.setText("");
      Stimulus2.setText(testConcept);
    }

    listOfCompletedStimuli.add(dataSet[currentStimulus].word);
    // Report number of stimuli still to go.
    String message;
    if (stimuliDone<=startCountdownAt) {
      message = " ";
    } else {
      message = InterfaceTexts.getString("labelForNumberUndone");
      message = message + Integer.toString(numberOfStimuli - stimuliDone);
    }
    progressLabel.invalidate();
    progressLabel.setText(message);
  } // End changeStimulus.

  void changeDimension () {
    if (presentingTutorial) {
      // currentDimension = value assigned in tutorialButton_actionPerformed.
      reflectedScale = false;
    } else {
      if (doneWithThisStimulus()) {
        // All dimensions rated.
        currentDimension = -1;
        return;
      } else {
        // Find an unrated dimension for the current stimulus.
        do {
          currentDimension = Math.abs(randomizer.nextInt() % NUMBER_OF_SCALES);
        } while (dataSet[currentStimulus].dimensionDone[currentDimension]);
      }
      reflectedScale = (randomizer.nextInt()>0);
    }
    if (reflectedScale) {
      slider1.setReflectedScale(true);
      leftAdjective0.setText(positiveModifiers[currentDimension][0]);
      leftAdjective1.setText(positiveModifiers[currentDimension][1]);
      leftAdjective2.setText(positiveModifiers[currentDimension][2]);
      leftAdjective3.setText(positiveModifiers[currentDimension][3]);
      leftAdjective4.setText(positiveModifiers[currentDimension][4]);
      rightAdjective0.setText(negativeModifiers[currentDimension][0]);
      rightAdjective1.setText(negativeModifiers[currentDimension][1]);
      rightAdjective2.setText(negativeModifiers[currentDimension][2]);
      rightAdjective3.setText(negativeModifiers[currentDimension][3]);
      rightAdjective4.setText(negativeModifiers[currentDimension][4]);
    } else {
      slider1.setReflectedScale(false);
      leftAdjective0.setText(negativeModifiers[currentDimension][0]);
      leftAdjective1.setText(negativeModifiers[currentDimension][1]);
      leftAdjective2.setText(negativeModifiers[currentDimension][2]);
      leftAdjective3.setText(negativeModifiers[currentDimension][3]);
      leftAdjective4.setText(negativeModifiers[currentDimension][4]);
      rightAdjective0.setText(positiveModifiers[currentDimension][0]);
      rightAdjective1.setText(positiveModifiers[currentDimension][1]);
      rightAdjective2.setText(positiveModifiers[currentDimension][2]);
      rightAdjective3.setText(positiveModifiers[currentDimension][3]);
      rightAdjective4.setText(positiveModifiers[currentDimension][4]);
    }
    leftAdjective0.invalidate();
    leftAdjective1.invalidate();
    leftAdjective2.invalidate();
    leftAdjective3.invalidate();
    leftAdjective4.invalidate();
    rightAdjective0.invalidate();
    rightAdjective1.invalidate();
    rightAdjective2.invalidate();
    rightAdjective3.invalidate();
    rightAdjective4.invalidate();
    ratingCard.validate();
  } // End changeDimension.

  void saveButton_actionPerformed(ActionEvent e) {
    // Record the rating and go to next dimension or stimulus or step.
    double scaleValue;
    if (! slider1.isSliderMoved()) return; // Movement of slider required.
    if (presentingTutorial) {
      slider1.snapToOrigin();
      tutorialButton_actionPerformed(dummyEvent);
      return;
    }
    scaleValue = slider1.getScaleValue();
    dataSet[currentStimulus].profile[currentDimension] = scaleValue;
    ratingsDone = ratingsDone + 1;
    sumSquaredRatings = sumSquaredRatings + (scaleValue*scaleValue);
    dataSet[currentStimulus].dimensionDone[currentDimension] = true;
    slider1.snapToOrigin();
    if (doneWithThisStimulus()) {
      dataSet[currentStimulus].itemDone = true;
      stimuliDone = stimuliDone +1;
      if (doneWithAllStimuli()){
        concludeRatings();
        return;
      } else {
        changeStimulus();
      }
    }
    changeDimension();
  } // End saveButton_actionPerformed.

  void editButton_actionPerformed(ActionEvent e) {
    if (! presentingTutorial) {
      if (editButton.getLabel().equalsIgnoreCase(InterfaceTexts.getString("correctButton"))) {
        editButton.invalidate();
        saveButton.invalidate();
        skipButton.invalidate();
        saveButton.setVisible(false);
        skipButton.setVisible(false);
        editButton.setLabel(InterfaceTexts.getString("noCorrectButton"));
        editPanel.invalidate();
        editPanel.setVisible(true);
      } else { // User clicked No-change.
        if (doneWithAllStimuli()){
          concludeSession();
        } else{
          editButton.invalidate();
          skipButton.invalidate();
          skipButton.setVisible(true);
          editButton.setLabel(InterfaceTexts.getString("correctButton"));
          editPanel.invalidate();
          editPanel.setVisible(false);
          if (usingSaveButton) {
            saveButton.invalidate();
            saveButton.setVisible(true);
          }
        }
      }
      this.validate();
    } else { // In tutorial.
      if (currentTutorialPage!=9) {return;} // Tutorial page 9 asks user to click Change button.
      tutorialButton_actionPerformed(dummyEvent);
    }
  }// End editButton_actionPerformed.

  void skipButton_actionPerformed(ActionEvent e) {
    skippedStimulus = false;
    if ((presentingTutorial)&(currentTutorialPage!=11)) {return;} // Tutorial page 11 asks user to click Skip button.
    if (!debuggingSkip) {
      areYouSureDialog confirmIt = new areYouSureDialog((Frame) appletFrame);
      confirmIt.show();
    } else {
      skippedStimulus = true;
    }
    if (presentingTutorial) {
      tutorialButton_actionPerformed(dummyEvent);
      return;
    }
    if (skippedStimulus) {
      // Skip the current stimulus.
      for (int i=0; i<NUMBER_OF_SCALES; i++) {
        dataSet[currentStimulus].profile[i] = MISSING_DATA;
        dataSet[currentStimulus].dimensionDone[i] = true;
      }
      dataSet[currentStimulus].itemDone = true;
      stimuliDone = stimuliDone + 1;
      if (doneWithAllStimuli()){
        concludeRatings();
        return;
      }
      changeStimulus();
      changeDimension();
    }
  }// End skipButton_actionPerformed.

  void slider1_propertyChange(PropertyChangeEvent e) {
    if (! presentingTutorial) {
      if (! usingSaveButton) {
        saveButton_actionPerformed(dummyEvent);
      }
    } else { // Tutorial actions.
      if (! saveButtonPanel.isVisible()) {
        slider1.snapToOrigin();
        tutorialButton_actionPerformed(dummyEvent);
      }
    }
  }// End slider1_propertyChange.

  void listOfCompletedStimuli_itemStateChanged(ItemEvent e) {
    if (presentingTutorial) {return;}
    if (concludingRatings) {editButton.setVisible(false);}
    skipButton.invalidate();
    skipButton.setVisible(true);
    // Restore Change button and get rid of stimuli list.
    editButton.invalidate();
    editButton.setLabel(InterfaceTexts.getString("correctButton"));
    editPanel.invalidate();
    editPanel.setVisible(false);
    if (usingSaveButton) {
      saveButton.invalidate();
      saveButton.setVisible(true);
    }
    if (doneWithAllStimuli()){tutorialPanel.setVisible(false);}
    // Find the item in the dataset.
    String item = listOfCompletedStimuli.getSelectedItem();
    currentStimulus = -1;
    while (! dataSet[++currentStimulus].word.equalsIgnoreCase(item)){};
    // Undo the item.
    for (int i=0; i<NUMBER_OF_SCALES; i++) {
      dataSet[currentStimulus].profile[i] = (new Double(NO_DATA)).doubleValue();
      dataSet[currentStimulus].dimensionDone[i] = false;
    }
    dataSet[currentStimulus].itemDone = false;
    listOfCompletedStimuli.remove(item);
    stimuliDone = listOfCompletedStimuli.getItemCount();
    // Re-rate the item.
    Stimulus1.invalidate();
    Stimulus2.invalidate();
    if (item.indexOf(TEXT_DELIMITER)>0) {
      Stimulus1.setText(item.substring(0,item.indexOf(TEXT_DELIMITER)));
      Stimulus2.setText(item.substring(item.indexOf(TEXT_DELIMITER)+1));
    } else {
      Stimulus1.setText("");
      Stimulus2.setText(item);
    }
    listOfCompletedStimuli.add(dataSet[currentStimulus].word);
    changeDimension();
  } // End listOfCompletedStimuli_itemStateChanged.

  void submitButton_actionPerformed(ActionEvent e) {
    respondentInfo = yourNameField.getText() + NEW_LINE;
    respondentInfo = respondentInfo + address1Field.getText() + NEW_LINE;
    respondentInfo = respondentInfo + address2Field.getText() + NEW_LINE;
    respondentInfo = respondentInfo + cityField.getText() + NEW_LINE;
    deliverData();
  } // End submitButton_actionPerformed.

  boolean doneWithThisStimulus () {
    // Check if all dimensions have been rated.
    boolean allDimensionsDone = true;
    for (int i = 0; i < NUMBER_OF_SCALES; i++) {
      allDimensionsDone = allDimensionsDone & dataSet[currentStimulus].dimensionDone[i];
    }
    return allDimensionsDone;
  } // End doneWithThisStimulus.

  boolean doneWithAllStimuli () {
    return (stimuliDone >= numberOfStimuli);
  } // End doneWithAllStimuli.

  void concludeRatings() {
    concludingRatings = true;
    // Give user a last chance to correct ratings.
    progressLabel.invalidate();
    progressLabel.setText("");
    Stimulus1.invalidate();
    Stimulus2.invalidate();
    Stimulus1.setText("");
    Stimulus2.setText("");
    tutorialPanel.setVisible(true);
    tutorialButton.setVisible(false);
    skipButton.setVisible(false);
    saveButton.setVisible(false);
    editButton.setVisible(true);
    String stringName = "concludingQuery";
    for (int i=0; i<NUMBER_OF_TUTORIAL_LINES; i++) {
      tutorialLine[i].invalidate();
      tutorialLine[i].setText(InterfaceTexts.getString(stringName + (new Integer(i+1)).toString()));
    }
    tutorialPanel.invalidate();
    stimulusPanel.invalidate();
    leftAdjectivePanel.invalidate();
    rightAdjectivePanel.invalidate();
    adverbPanel.invalidate();
    saveButtonPanel.invalidate();
    editPanel.invalidate();

    editButton_actionPerformed(dummyEvent);
  } // End concludeRatings.

  void concludeSession() {
    // Generate respondent's PIN.
    timeNow = System.currentTimeMillis();
    long PIN = (timeNow - baseTime);
    PINstring = new Long(PIN).toString();
    respondentInfo = "";
    if (acquiringPersonalData) {
      // Present the name-address form.
      appletCardLayout.show(this,"paymentCard");
    } else {
      deliverData();
    }
  } // End concludeSession.

  void deliverData() {
    URL url;
    URLConnection urlConn;
    DataOutputStream printout;
    BufferedReader input;
    String outputData, backtalk, str;
    long minutes;
    backtalk = "";
    // Begin outputData with identification of stimulus set. (The archiving program will make time the first item.)
    // Then show the number of skipped stimuli.
    outputData = QUOTE + nameOfArchive + QUOTE + COMMA_SPACE + (new Integer(numberOfSkippedStimuli)).toString() + COMMA_SPACE;
    timeIncrement = timeNow - startTime;
    // Next show the number of minutes respondent took for ratings (not including background questions or tutorial).
    ratingTime = timeIncrement / 60000;
    outputData = outputData + (new Long(ratingTime)).toString() + COMMA_SPACE;
    // Next show the mean polarization of ratings.
    outputData = outputData + (new Double(Math.round(100*sumSquaredRatings/ratingsDone)/100)).toString() + NEW_LINE;
    // Store respondent information.
    if (! anonymous) {
      outputData = outputData + respondentInfo + NEW_LINE;
    }
    // Store answers to background questions.
    questionIndex = -1;
    while (++questionIndex < numberOfQuestions) {
      // Each line contains number of option chosen starting at zero, comma, text of chosen option.
      BackgroundQuestion anItem = (BackgroundQuestion) querySet.elementAt(questionIndex);
      outputData = outputData + QUOTE + anItem.EnglishOption[anItem.answer] + QUOTE + COMMA_SPACE;
      outputData = outputData + (new Integer(anItem.answer)).toString() + NEW_LINE;
    }
    // Store stimuli and EPA ratings on a line each.
    for (int i=0; i<numberOfStimuli; i++) {
      outputData = outputData + QUOTE + dataSet[i].keyword + QUOTE; // Output shows U.S.A. keyword.
      for (int j=0; j<NUMBER_OF_SCALES; j++) {
        outputData = outputData + COMMA_SPACE + (new Double(dataSet[i].profile[j])).toString();
      }
      outputData = outputData + NEW_LINE;
    }
    /*
    * POST outputData to Transform on IU Web server.
    * Routine from URL: http://www.javaworld.com/javaworld/javatips/jw-javatip34.html
    */
    try {
      // URL of CGI-Bin script assuming that the applet directory has name: projectIdentification.
      url = new URL("http://www.indiana.edu/~socpsy/Magellan/transform.cgi?socpsy/Magellan/" + projectIdentification + "/archiver.tpl");
      // URL connection channel.
      urlConn = url.openConnection();
      // Let the run-time system (RTS) know that we want input.
      urlConn.setDoInput (true);
      // Let the RTS know that we want to do output.
      urlConn.setDoOutput (true);
      // No caching, we want the real thing.
      urlConn.setUseCaches (false);
      // Specify the content type.
      urlConn.setRequestProperty
        ("Content-Type", "application/x-www-form-urlencoded");
      // Send POST output.
      printout = new DataOutputStream (urlConn.getOutputStream ());
      String content =
        "project=" + URLEncoder.encode (projectIdentification) +
        "&stimulusSet=" + URLEncoder.encode (stimuliSetIdentification) +
        "&emailAddress=" + URLEncoder.encode (emailAddress) +
        "&respondentInfo=" + URLEncoder.encode (respondentInfo) +
        "&pin=" + URLEncoder.encode (PINstring) +
        "&data=" + URLEncoder.encode (outputData);
      printout.writeBytes (content);
      printout.flush ();
      printout.close ();
      // Get response data.
      input = new BufferedReader (new InputStreamReader (urlConn.getInputStream()));
      while (null != (str = input.readLine()) ) {backtalk = backtalk + str;}
      input.close ();
      }
    catch (MalformedURLException me) {System.err.println("MalformedURLException: " + me);}
    catch (IOException ioe) {System.err.println("IOException: debug=" + ioe);}
    /*
    * End of borrowed routine to POST data to Transform.
    */
    // Give success or failure message to respondent.
    if (backtalk.indexOf("OKAY")>-1){
      // Data stored successfully.
      if (successURL != null) {
        // End with a success web page.
        context.showDocument(successURL);
      } else {
        // Present final message, including PIN.
        Stimulus1.setText(InterfaceTexts.getString("pinText"));
        Stimulus2.setText(PINstring);
        tutorialPanel.setVisible(true);
        tutorialButton.setVisible(false);
        slider1.setVisible(false);
        leftAdjectivePanel.setVisible(false);
        rightAdjectivePanel.setVisible(false);
        adverbPanel.setVisible(false);
        saveButtonPanel.setVisible(false);
        progressPanel.setVisible(false);
        editPanel.setVisible(false);
        this.invalidate();
        ratingCard.invalidate();
        tutorialPanel.invalidate();
        tutorialTextPanel.invalidate();
        stimulusPanel.invalidate();
        String stringName = "thankYou";
        for (int i=0; i<NUMBER_OF_TUTORIAL_LINES; i++) {
          tutorialLine[i].invalidate();
          tutorialLine[i].setText(InterfaceTexts.getString(stringName + (new Integer(i+1)).toString()));
        }
        appletCardLayout.show(this,"ratingCard");
        this.validate();
      }
    } else {
      // Data storage failed. Give the PIN on the failure card.
      pinTextLabel.setText(InterfaceTexts.getString("pinText"));
      pinLabel.setText(PINstring);
      appletCardLayout.show(this,"stopCard");
    }
    System.err.println(backtalk);
  } // End deliverData.

  void giveTutorial() {
    presentingTutorial = true;
    appletCardLayout.show(this,"ratingCard");
    tutorialPanel.setVisible(true);
    tutorialButton.setVisible(true);
    stimulusPanel.setVisible(false);
    slider1.setVisible(false);
    leftAdjectivePanel.setVisible(false);
    rightAdjectivePanel.setVisible(false);
    adverbPanel.setVisible(false);
    saveButtonPanel.setVisible(false);
    progressPanel.setVisible(false);
    editPanel.setVisible(false);
    currentTutorialPage = 1;
    String stringName = "Tutorial_" + (new Integer(currentTutorialPage)).toString() + "_";
    for (int i=0; i<NUMBER_OF_TUTORIAL_LINES; i++) {
      tutorialLine[i].invalidate();
      tutorialLine[i].setText(InterfaceTexts.getString(stringName + (new Integer(i+1)).toString()));
    }
    this.validate();
  } // End giveTutorial.

  void tutorialButton_actionPerformed(ActionEvent e) {
    switch(++currentTutorialPage){
      case 2:
        stimulusPanel.invalidate();
        Stimulus2.invalidate();
        stimulusPanel.setVisible(true);
        Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus1"));
        break;
      case 3:
        slider1.invalidate();
        slider1.setVisible(true);
//        tutorialButton.setVisible(false);
        tutorialButton.setVisible(true);
        break;
      case 4:
        tutorialButton.setVisible(true);
        adverbPanel.setVisible(true);
        break;
      case 5:
        leftAdjectivePanel.setVisible(true);
        rightAdjectivePanel.setVisible(true);
        currentDimension = 0;
        changeDimension();
        break;
      case 6:
        currentDimension = 1;
        changeDimension();
        break;
      case 7:
        currentDimension = 2;
        changeDimension();
        tutorialButton.setVisible(false);
        if (usingSaveButton) {
          saveButtonPanel.setVisible(true);
        }
        break;
      case 8:
        Stimulus2.invalidate();
        Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus2"));
        break;
      case 9:
        progressPanel.invalidate();
        progressPanel.setVisible(true);
        break;
      case 10:
        tutorialButton.invalidate();
        tutorialButton.setVisible(true);
        Stimulus2.invalidate();
        Stimulus2.setText("");
        editButton.invalidate();
        editButton.setLabel(InterfaceTexts.getString("noCorrectButton"));
        listOfCompletedStimuli.add(InterfaceTexts.getString("TutorialStimulus1"));
        listOfCompletedStimuli.add(InterfaceTexts.getString("TutorialStimulus2"));
        editPanel.invalidate();
        editPanel.setVisible(true);
        break;
      case 11:
        Stimulus2.invalidate();
        editPanel.invalidate();
        tutorialButton.invalidate();
        tutorialButton.setVisible(false);
        Stimulus2.setText(InterfaceTexts.getString("TutorialStimulus3"));
        editButton.invalidate();
        editButton.setLabel(InterfaceTexts.getString("correctButton"));
        listOfCompletedStimuli.removeAll();
        editPanel.setVisible(false);
        break;
      case 12:
        tutorialButton.setVisible(true);
        stimulusPanel.setVisible(false);
        slider1.setVisible(false);
        leftAdjectivePanel.setVisible(false);
        rightAdjectivePanel.setVisible(false);
        adverbPanel.setVisible(false);
        saveButtonPanel.setVisible(false);
        progressPanel.setVisible(false);
        editPanel.setVisible(false);
        tutorialButton.setLabel(InterfaceTexts.getString("questionnaireContinueButton"));

        break;
      default :
        presentingTutorial = false;
        numberOfSkippedStimuli = 0;
        tutorialPanel.setVisible(false);
        stimulusPanel.setVisible(true);
        slider1.setVisible(true);
        leftAdjectivePanel.setVisible(true);
        rightAdjectivePanel.setVisible(true);
        adverbPanel.setVisible(true);
        saveButtonPanel.setVisible(true);
        progressPanel.setVisible(true);
        changeStimulus();
        changeDimension();
        return;
    }
    // Present the text for the current page.
    String stringName = "Tutorial_" + (new Integer(currentTutorialPage)).toString() + "_";
    for (int i=0; i<NUMBER_OF_TUTORIAL_LINES; i++) {
      tutorialLine[i].invalidate();
      tutorialLine[i].setText(InterfaceTexts.getString(stringName + (new Integer(i+1)).toString()));
    }
    // Delete tutorial's reference to Save button if not using one.
    if ((currentTutorialPage==7) & (! usingSaveButton)) {tutorialLine[2].setText("");}
    this.validate();
  } // End tutorialButton_actionPerformed.


}
