package magellan;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class areYouSureDialog extends Dialog {
  static final long PAUSE_TIME = 50; // milleseconds. Reduced from 5000 after Kelley analysis
  Panel dialogPanel = new Panel();
  Panel sureButtonPanel = new Panel();
  Label areYouSureLabel = new Label();
  Button cancelSkip = new Button();
  Button confirmSkip = new Button();
  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();

  public areYouSureDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(dialogPanel);
      pack();
      // Center the dialog.
      Point upperLeftCorner = frame.getLocation();
      Dimension parentSize = frame.getSize();
      Dimension dialogSize = this.getSize();
      upperLeftCorner.translate((parentSize.width - dialogSize.width) / 2, (parentSize.height - dialogSize.height) / 2);
      this.setLocation(upperLeftCorner);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public areYouSureDialog(Frame frame) {
    this(frame, "", true);
  }

  void jbInit() throws Exception {
    areYouSureLabel.setAlignment(1);
    areYouSureLabel.setBackground(Color.pink);
    dialogPanel.setBackground(Color.pink);
    dialogPanel.setLayout(borderLayout1);
    sureButtonPanel.setBackground(Color.pink);
    sureButtonPanel.setLayout(flowLayout1);
    cancelSkip.setActionCommand("Cancel");
    cancelSkip.setBackground(Color.orange);
    confirmSkip.setActionCommand("Confirmed");
    confirmSkip.setBackground(Color.orange);
    flowLayout1.setHgap(15);
    dialogPanel.add(areYouSureLabel, BorderLayout.CENTER);
    dialogPanel.add(sureButtonPanel, BorderLayout.SOUTH);
    sureButtonPanel.add(confirmSkip, null);
    sureButtonPanel.add(cancelSkip, null);
    areYouSureLabel.setText(Surveyor.InterfaceTexts.getString("areYouSureMessage"));
    cancelSkip.setLabel(Surveyor.InterfaceTexts.getString("cancelSkipButton"));
    confirmSkip.setLabel(Surveyor.InterfaceTexts.getString("confirmSkipButton"));
    cancelSkip.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cancelSkip_actionPerformed(e);
      }
    });
    confirmSkip.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        confirmSkip_actionPerformed(e);
      }
    });
  }
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }
  void cancel() {
    dispose();
  }

  void confirmSkip_actionPerformed(ActionEvent e) {
    Surveyor.numberOfSkippedStimuli = Surveyor.numberOfSkippedStimuli + 1;
    Surveyor.skippedStimulus = true;
    areYouSureLabel.invalidate();
    sureButtonPanel.invalidate();
    cancelSkip.invalidate();
    confirmSkip.invalidate();
    areYouSureLabel.setText(Surveyor.InterfaceTexts.getString("pleaseWait"));
    cancelSkip.setVisible(false);
    confirmSkip.setVisible(false);
    validate();
    pause();
    cancel();
  }

  void cancelSkip_actionPerformed(ActionEvent e) {
    Surveyor.skippedStimulus = false;
    cancel();
  }

  void pause(){
    // Punish skipping with a pause.
    Date start = new Date();
    Date stop = new Date(start.getTime()+PAUSE_TIME);
    while ((new Date()).before(stop)){}; // Pause by looping.
  }
}